#include "AneuMeshLoader.h"
#include "Exeptions.h"

#include <fstream>
#include <vector>

void AneuMeshLoader::LoadMesh(const std::string& filename) {
    std::ifstream file(filename);
    if (!file) {
        throw BadFileFormatException();
    }

    std::cout << filename << " opened, please wait" << std::endl;
    int cnt, dim;
    file >> cnt >> dim;
    nodes.reserve(cnt);
    for (int i = 1; i <= cnt; ++i) {
        size_t id = i;
        std::vector<float> coord(dim);
        for (int j = 1; j <= dim; ++j) {
            file >> coord[j - 1];
        }
        nodes.emplace_back(id, coord, true); //!!! ИСПРАВЛЕНО emplace_back принимает арнументы конструктора Node. Зачем лишний раз создавать объект?
    }

    file >> cnt >> dim;
    for (int i = 1; i <= cnt; ++i) {
        size_t id = i;
        std::vector<size_t> coord(dim);
        size_t materialId;
        file >> materialId;
        for (int j = 1; j <= dim; ++j) {
            file >> coord[j - 1];
        }
        finiteElements.emplace_back(id, materialId, coord);//!!! ИСПРАВЛЕНО emplace_back принимает арнументы конструктора. Зачем лишний раз создавать объект?
    }

    file >> cnt >> dim;
    for (int i = 1; i <= cnt; ++i) {
        size_t id = i;
        std::vector<size_t> coord(dim);
        size_t materialId;
        file >> materialId;
        for (int j = 1; j <= dim; ++j) {
            file >> coord[j - 1];
        }
        boundaryFiniteElements.emplace_back(id, materialId, coord); //!!! ИСПРАВЛЕНО emplace_back принимает арнументы конструктора. Зачем лишний раз создавать объект?
    }
    file.close();
    std::cout << "Aneu file downloaded" << std::endl;
}


